$.fn.gallery3d = function () {
	$(this).each(function () {
		var self = this;
		var container = $(self).find("div.container:first");
		var width = $(self).find("div.container:first").width();
		var height = $(self).find("div.container:first").height();
		var images = $(self).find("div.image");
		var nitems = images.size();
		var radius = width/Math.sqrt(2)/Math.sqrt(1-Math.cos(2*Math.PI/nitems));
		var dg = 360 / nitems;
		var rotation = 0;
		var active = 0;
		var radius2 = 0;
		
		var rotate = function(direction) {
			radius2 = (radius2 + direction*( dg ));
			container.css('transform', 'rotateY(' + radius2 + 'deg)');
			container.css('-webkit-transform', 'rotateY(' + radius2 + 'deg)');
			container.css('-moz-transform', 'rotateY(' + radius2 + 'deg)');
			container.css('-ms-transform', 'rotateY(' + radius2 + 'deg)');
			container.css('-o-transform', 'rotateY(' + radius2 + 'deg)');
		}
		
		var moveRight = function () {
			var active = $(self).find("div.image.active");
			var prev = active.prev();
			if (!prev.is("div")) {
				var prev = $(self).find("div.image:last");
			}
			active.removeClass("active");
			prev.addClass("active");
			prev.focus();
			rotation = rotation + dg;
			rotate(1);			
		}
		
		var moveLeft = function () {
			var active = $(self).find("div.image.active");
			var next = active.next();
			if (!next.is("div")) {
				var next = $(self).find("div.image:first");
			}
			active.removeClass("active");
			next.addClass("active");
			next.focus();
			rotation = rotation - dg;
			rotate(-1);
		}
			
		var transform = function () {
			$(self).css("perspective", 500);
			$(self).css("-webkit-perspective", 500);
			$(self).css("-moz-perspective", 500);
			$(self).css("-ms-perspective", 500);
			$(self).css("-o-perspective", 500);
			
			$(self).css("perspective-origin", "50% 50%");
			$(self).css("-webkit-perspective-origin", "50% 50%");
			$(self).css("-moz-perspective-origin", "50% 50%");
			$(self).css("-ms-perspective-origin", "50% 50%");
			$(self).css("-o-perspective-origin", "50% 50%");
			
			container.css("transform-style", "preserve-3d");
			container.css("-webkit-transform-style", "preserve-3d");
			container.css("-moz-transform-style", "preserve-3d");
			container.css("-ms-transform-style", "preserve-3d");
			container.css("-o-transform-style", "preserve-3d");
			
			images.each(function (i) {
				if (i==0) {
					$(this).addClass("active");
				}
				$(this).css({
					'transform': 'rotateY('+i*dg+'deg) translateZ('+radius+'px)',
					'-webkit-transform': 'rotateY('+i*dg+'deg) translateZ('+radius+'px)',
					'-moz-transform': 'rotateY('+i*dg+'deg) translateZ('+radius+'px)',
					'-ms-transform': 'rotateY('+i*dg+'deg) translateZ('+radius+'px)',
					'-o-transform': 'rotateY('+i*dg+'deg) translateZ('+radius+'px)'
				});
				
			});
		}
		var init = function () {
			var incomplete = $(self).find("img:not(.load_complete)");
			if (incomplete.size() == 0) {
				transform();
			}
		}
		
		var centerimg = function (img) {
			var parent = $(img).parent();
			var h = $(img).height();
			var top = (parent.height() - h) / 2;
			$(img).css({top: top});
		}
		
		$(this).find("img").each(function () {
			if (this.complete) {
				$(this).addClass("load_complete");
				centerimg(this);
			}
			$(this).load(function () {
				$(this).addClass("load_complete");
				centerimg(this);
				init();
			});
			init();
		});
		
		$(window).keydown(function (e) {
			var code = e.keyCode;
			if (code == 39) {
				moveLeft();
			}
			if (code == 37) {
				moveRight();
			}
		});
		
		$(self).find("a").click(function (e) {
			e.preventDefault();
			var active = $(self).find("div.image.active");
			var prev = active.prev();
			var parent = $(this).parent();
			if (!prev.is("div")) {
				var prev = $(self).find("div.image:last");
			}
			var next = active.next();
			if (!next.is("div")) {
				var next = $(self).find("div.image:first");
			}
			if (parent.is(next)) {
				moveLeft();
			}
			else if (parent.is(prev)) {
				moveRight();
			}
		});
	});
}

$(document).ready(function () {
	$(".gallery").gallery3d();
});